/*Liest die Config Daten aus dem EEPRom
  Schreibt neue Daten ins EEProm
  Stellt die Default-Daten wieder her
*/

#include "main.h"

u08 eep_mastermode[2] __attribute__ ((section (".eeprom")));
u08 eep_rs232ubrr[2] __attribute__ ((section (".eeprom")));
u08 eep_srspeed[2] __attribute__ ((section (".eeprom")));
u08 eep_interface_active[2] __attribute__ ((section (".eeprom")));
u08 eep_interface_source[2] __attribute__ ((section (".eeprom")));
u08 eep_halt_on_err[2] __attribute__ ((section (".eeprom")));
u08 eep_send_funk_retry[2] __attribute__ ((section (".eeprom")));

u08 eep_loadconf(void) {
u08 read1,read2;
u08 all_right = 1;
//Mastermode
read1 = eeprom_read_byte(&eep_mastermode[0]);
read2 = eeprom_read_byte(&eep_mastermode[1]);
if (read1 != read2) all_right = 0;
mastermode = read2;
//Mastermode
read1 = eeprom_read_byte(&eep_rs232ubrr[0]);
read2 = eeprom_read_byte(&eep_rs232ubrr[1]);
if (read1 != read2) all_right = 0;
rs232ubrr = read2;
//Mastermode
read1 = eeprom_read_byte(&eep_srspeed[0]);
read2 = eeprom_read_byte(&eep_srspeed[1]);
if (read1 != read2) all_right = 0;
srspeed = read2;
//Um schnellen Zugriff in der Interrupt Routine auf die Werte zu haben
srspeed_3_2 = read2*3/2;
srspeed_5_2 = read2*5/2;
//Mastermode
read1 = eeprom_read_byte(&eep_interface_active[0]);
read2 = eeprom_read_byte(&eep_interface_active[1]);
if (read1 != read2) all_right = 0;
interface_active = read2;
//Mastermode
read1 = eeprom_read_byte(&eep_interface_source[0]);
read2 = eeprom_read_byte(&eep_interface_source[1]);
if (read1 != read2) all_right = 0;
interface_source = read2;
//Halt_on_error
read1 = eeprom_read_byte(&eep_halt_on_err[0]);
read2 = eeprom_read_byte(&eep_halt_on_err[1]);
if (read1 != read2) all_right = 0;
halt_on_err = read2;
//Send_funk_retry
read1 = eeprom_read_byte(&eep_send_funk_retry[0]);
read2 = eeprom_read_byte(&eep_send_funk_retry[1]);
if (read1 != read2) all_right = 0;
send_funk_retry = read2;
return all_right;
}

void eep_writeconf(void) {
eeprom_write_byte(&eep_mastermode[0],mastermode);
eeprom_write_byte(&eep_mastermode[1],mastermode);
eeprom_write_byte(&eep_rs232ubrr[0],rs232ubrr);
eeprom_write_byte(&eep_rs232ubrr[1],rs232ubrr);
eeprom_write_byte(&eep_srspeed[0],srspeed);
eeprom_write_byte(&eep_srspeed[1],srspeed);
eeprom_write_byte(&eep_interface_active[0],interface_active);
eeprom_write_byte(&eep_interface_active[1],interface_active);
eeprom_write_byte(&eep_interface_source[0],interface_source);
eeprom_write_byte(&eep_interface_source[1],interface_source);
eeprom_write_byte(&eep_halt_on_err[0],halt_on_err);
eeprom_write_byte(&eep_halt_on_err[1],halt_on_err);
eeprom_write_byte(&eep_send_funk_retry[0],send_funk_retry);
eeprom_write_byte(&eep_send_funk_retry[1],send_funk_retry);
}

void eep_restoredefault(void) {
u08 nun = 1;
mastermode = default_mastermode;
rs232ubrr = default_rs232ubrr;
srspeed = default_srspeed;
interface_active = default_interface_active;
interface_source = default_interface_source;
halt_on_err = default_halt_on_err;
send_funk_retry = default_send_funk_retry;
eep_writeconf();
//Lauflicht, zur Signalisierung des Schreibvorgangs
while (nun != 0) {
  leds = nun;
  waitms(200);
  nun <<= 1;
}
}
