// Funk I/O Routinen

#ifndef pc_dummy_mode

#include "main.h"

//Empfnger
u08 volatile rsync,zaeler,orbit,bcount;
u16 volatile rvalue,recfunk;
//Sender
u08 volatile sbcount,scount;
u16 volatile svalue;
//Empfang/Senden kontrolle
u08 nextsend;


void timer2_init(void) {
//Wir wollen: Interupt on Comparematch
OCR2 = 30; //Dummy, zum testen
TCNT2 = 0; //Reset Timer2
TIMSK |= 1<<OCIE2; //Timer2 Compare Match aktivieren
TCCR2 = 1<< WGM21 | 0x02; //Clear on Comparematch, Prescaler: 8
//TCCR2 = 1<< WGM21 | 0x05; //Clear on Comparematch, Prescaler: 128
}

/* Vector SIG_OUTPUT_COMPARE2 Size:
 mit Volatile:     ~276Word
 mit Register(1):   212Word
 mehrere srspeed:   164Word
 PORTD optimiert:   154Word
 XOR:               153Word
 rvlaue_l:          139Word
 svalue_l:          135Word
 ohne Register(1):  197Word
 zaeler_l:          193Word
 rsync_l:           180Word
 sbcout_l,scount_l: 176Word
 srspeed_l:         173Word
 bcount_l:          165Word
 orbit_l:           164Word
 srspeed_3_2_l:     161Word
 kein srspeed4:     156Word, ca 198 Taktzyklen fr die komplette Int. Routine
*/

SIGNAL(SIG_OUTPUT_COMPARE2) {
//Empnger
u08 a;
//Sender
u08 sbit;
//Lokale Variablen, um das Volatile der globalen zu vermeiden
u16 rvalue_l,svalue_l;
u08 zaeler_l;
u08 rsync_l;
u08 bcount_l;
u08 orbit_l;
u08 sbcount_l,scount_l;
u08 srspeed_l;
u08 srspeed_3_2_l;
// Diese Routine kann nicht schnell genug sein !!!

//Digitale Hysterese
zaeler_l = zaeler;
srspeed_l = srspeed;
if (fin == 0) {
  if (zaeler_l > 0) {
    zaeler_l--;
  }
} else {
  if (zaeler_l < (srspeed_l>>2)) {
    zaeler_l++;
  }
}
orbit_l = orbit;
a = orbit_l;
if (zaeler_l == 0) a = 0;
if (zaeler_l == (srspeed_l>>2)) a = 1;
zaeler = zaeler_l;
//Startbit erkennen
rsync_l = rsync;
rsync_l++;
rvalue_l = rvalue;
bcount_l = bcount;
srspeed_3_2_l = srspeed_3_2;
if ((bcount_l == 0) && (a != orbit_l)) {
  if (a == 1) { //Start des Startbits
    rsync_l = 0;
  } else {
    if ((rsync_l > srspeed_3_2_l) && (rsync_l < srspeed_5_2)) {
      //Starbtit erkannt
      rsync_l = 0-srspeed_3_2_l;
      bcount_l = 12;
      rvalue_l = 1;
    }
  }
}
//Bits empfangen
if (bcount_l != 0) {
  if (rsync_l < srspeed_l ) {
    if (a != orbit_l) { //Pegelwechsel entdeckt
      rvalue_l <<= 1;
      rvalue_l |= a;
    }
  }
  if (rsync_l == srspeed_3_2_l) { //Nchstes Bit
    rsync_l = 0-srspeed_l/2;
    bcount_l--;
  }
  if (bcount_l == 0) { //Empfang komplett
    recfunk = rvalue_l;
  }
}
rvalue = rvalue_l;
rsync = rsync_l;
bcount = bcount_l;
orbit = a;
//Das Senden der Daten
sbit = 0;
sbcount_l= sbcount;
scount_l = scount;
if (sbcount_l != 0)  {
  svalue_l = svalue;
  sbit = (svalue_l ^ sbcount_l) & 1;
  scount_l++;
  if (scount_l == srspeed_l) {
    scount_l = 0;
    if ((sbcount_l & 1) == 0) {
      svalue_l >>= 1;
    }
    sbcount_l--;
  }
  svalue = svalue_l;
}
sbcount = sbcount_l;
scount = scount_l;
//Setzen des 433MHZ Sender Pins
if (sbit == 0) {
  PORTD &= ~(1<<2);//Clear bit
}else{
  PORTD |= (1<<2); //Set bit
}
}

#endif

u08 io_funk_send(void) {
//0 = ok, 1 = empfange grade, 2 = gesendetes, wurde fehlerhaft empfangen, 3 = nichts zusenden
u16 senden_orig,senden_retry,senden;
u08 retry_no;
if ((send_funk_status() != 0) && (nosend == 0) &&
   (bcount == 0)&&(orbit == 0)&&(recfunk == 0)) { //wenn kein Empfang){ //Wenn nicht leer
  //Bereiten wir die Daten vor
  senden_orig = send_funk_get();
  senden = senden_orig<<1;
  senden_retry = senden | 0x0400; //Retry Bit setzen
  senden += parity(senden);
  senden_retry += parity(senden_retry);
  senden = (senden<<1) | 0x2001;
  senden_retry = (senden_retry<<1) |0x2001;
  senden = (mirror_word(senden))>>1;
  senden_retry = (mirror_word(senden_retry))>>1;
  if ((bcount == 0)&&(orbit == 0)&&(recfunk == 0)) { //wenn kein Empfang
    if (nextsend == 0) {
      swingin();
    }
    nextsend = 1;
    for (retry_no = 0;retry_no <= send_funk_retry;retry_no++) {
      //Daten zum senden in variablen schreiben
      if (retry_no == 0) {
        svalue = senden;
      } else {
        svalue = senden_retry;
      }
      sbcount = 28;
      //Warten, bis Daten gesendet
      while (sbcount != 0) { //Daten sind raus
        asm volatile ("nop");
      }
      while (bcount != 0) {  //Daten wurden empfangen
        asm volatile ("nop");
      }
      if (((recfunk >> 1) & 0x01FF) == senden_orig) { //Senden Erfolgreich
        recfunk = 0;
        if (send_funk_status() == 0) { //alles akutell anliegende gesendet
          nosend = 96; //3sec darf nichts neues gesendet werden
          if (mastermode == 0) {
            nosend = 255; //Slave muss wieder schweigen
          }
        }
        return 0;
      }
      waitms(2);
    }
    /* Das Senden hat irgenwie nicht geklappt, daher kann auch davon
    ausgegangen werden, dass die Daten erst recht nicht empfangen wurden,
    zurck in den Buffer - auf ein Neues */
    send_funk_put_next(senden_orig);
    nextsend = 0;
    nosend = 96;//3sec schweigen
    if (mastermode == 0) {
      nosend = 255;
    }
    return 2;
  } else {
    /*Die Daten waren bereits vorbereitet, konnten im letzten
     Augenblick aber doch nicht gesendet werden, somit werden
     sie zurck in den Ringbuffer geschrieben */
    send_funk_put_next(senden_orig);
    nextsend = 0;
    nosend = 96;//3sec schweigen
    if (mastermode == 0) {
      nosend = 255;
    }
    return 1;
  }
} else { //keine Daten oder senden verboten oder gerade am empfangen
  nextsend = 0;
  return 3;
}
}

void io_funk_rec(void) {
u16 recfunk_l;
/*recfunk ist eine 16Bit Variable, es sind also mehrere
Takte zur Lschung erforderlich, und da nicht grade wrend
des Lschvorgangs neue Daten hineingeschrieben werden sollen
*/
cli();
recfunk_l = recfunk;
recfunk = 0;
sei();
if ((recfunk_l & 0xF800) == 0x0800) {
  nosend = 64; //2 sec darf erstmal nichts neues gesendet werden
  if (parity(recfunk_l & 0x07FF) == 0) {
    rec_funk_put((recfunk_l>>1) & 0x01FF);
  }

}
}

u16 mirror_word(u16 val) {
u08 nun;
u16 result;
result = 0;
for (nun = 0;nun <16;nun++) {
  result <<= 1;
  result |= (val & 1);
  val >>= 1;
}
return result;
}

u08 parity(u16 val) {
u08 parit = 0;
while (val > 0) {
  if ((val & 1) == 1) //Wenn high Bit
    parit = 1-parit; //Bit toggeln
  val >>= 1;
}
return parit;
}

void swingin(void) {
u16 nun;
//344MHZ Sender Pin alle 400 Takte toggeln, und das 2000 mal -> 240msec
//clear bit soll ein wenig berwiegen
for (nun = 0;nun < 2000; nun++) {
PORTD |= (1<<2); //Set bit
_delay_loop_2(380/4);
PORTD &= ~(1<<2);//Clear bit
_delay_loop_2(420/4);
}
}
