#ifndef MAIN_H
 #define MAIN_H


//Externe Funktionen
#include <stdlib.h>
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/delay.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <string.h>
#include <math.h>

//Um zu wissen fr was uint8_t u.s.w. steht siehe inttypes.h
typedef uint8_t  u08;
typedef int8_t   s08;
typedef uint16_t u16;
typedef int16_t  s16;

#define F_CPU 8000000 // 8MHZ

//Globale Variablen fr die Konfiguration / Status
extern u08 mastermode;
extern u08 rs232ubrr;
extern u08 volatile srspeed;
extern u08 volatile srspeed_3_2;
extern u08 volatile srspeed_5_2;
extern u08 interface_active;
extern u08 interface_source;
extern u08 halt_on_err;
extern u08 send_funk_retry;
extern u08 volatile ping_next;
extern u08 volatile connected_rx;
extern u08 volatile connected_tx;
extern u08 volatile nosend;

//Weitere Quellen
#include "main.h"
#include "human-io.h"
#include "rs232_io.h"
#include "funk_io.h"
#include "eeprom_config.h"
#include "ad_converter.h"
#include "ringbuffer.h"

//Funktionsprototypen:
void waitms(uint16_t zeitms);
void error(u08 e_code);
void fifo_error(u08 e_code);
void control(void);
void syscommand(u08 value);
void movedata(void);
void sysinit(void);
int main(void);

#endif

