/*Hier werden 4 Ringbuffer verwaltet
init (leer):

Betrieb:
get: wenn free < size -> lesen, free++, read++
put: wenn free != 0 -> schreiben, free--, write++
*/


#include "main.h"

//was ber Funk empfangen wurde
u16 rec_funk[rec_funk_size];
u08 rec_funk_read;
u08 rec_funk_write;
u08 rec_funk_free = rec_funk_size;

//was ber RS232 gesendet werden soll
u08 send_232[send_232_size];
u08 send_232_read;
u08 send_232_write;
u08 send_232_free = send_232_size;

//was ber RS232 empfangen wurde
u08 volatile rec_232[rec_232_size];
u16 rec_232_read;
u16 volatile rec_232_write;
u16 volatile rec_232_free = rec_232_size;

//war ber Funk gesendet werden soll
u08 send_funk_read;
u08 send_funk_write;
u08 send_funk_free = send_funk_size;
u16 send_funk[send_funk_size];

u08 send_funk_status(void) {
u08 status;
status = 1;
if (send_funk_free == 0) status = 2; //voll
if (send_funk_free == send_funk_size) status = 0; //leer
return status;
}

void send_funk_put(u16 value) {
if (send_funk_free != 0) {
  send_funk[send_funk_write] = value;
  send_funk_write++;
  send_funk_free--;
  if (send_funk_write == send_funk_size) {
    send_funk_write = 0;
  }
} else
  fifo_error(7);
}

void send_funk_put_next(u16 value) {
if (send_funk_free != 0) {
  if (send_funk_read == 0) {
    send_funk_read = send_funk_size;
  }
  send_funk_read--;
  send_funk_free--;
  send_funk[send_funk_read] = value;
} else
  fifo_error(7);

}

u16 send_funk_get(void) {
u16 value = 0;
if (send_funk_free != send_funk_size) {
  value = send_funk[send_funk_read];
  send_funk_read++;
  send_funk_free++;
  if (send_funk_read == send_funk_size) {
    send_funk_read = 0;
  }
} else
  fifo_error(11);
return value;
}

u08 rec_funk_status(void) {
u08 status;
status = 1;
if (rec_funk_free == 0) status = 2; //voll
if (rec_funk_free == rec_funk_size) status = 0; //leer
return status;
}

void rec_funk_put(u16 value) {
if (rec_funk_free != 0) {
  rec_funk[rec_funk_write] = value;
  rec_funk_write++;
  rec_funk_free--;
  if (rec_funk_write == rec_funk_size) {
    rec_funk_write = 0;
  }
} else
  fifo_error(4);
}

u16 rec_funk_get(void) {
u16 value = 0;
if (rec_funk_free != rec_funk_size) {
  value = rec_funk[rec_funk_read];
  rec_funk_read++;
  rec_funk_free++;
  if (rec_funk_read == rec_funk_size) {
    rec_funk_read = 0;
  }
} else
  fifo_error(8);
return value;
}

u08 send_232_status(void) {
u08 status;
status = 1;
if (send_232_free == 0) status = 2; //voll
if (send_232_free == send_232_size) status = 0; //leer
return status;
}

void send_232_put(u08 value) {
if (send_232_free != 0) {
  send_232[send_232_write] = value;
  send_232_write++;
  send_232_free--;
  if (send_232_write == send_232_size) {
    send_232_write = 0;
  }
} else
  fifo_error(5);
}

u08 send_232_get(void) {
u08 value = 0;
if (send_232_free != send_232_size) {
  value = send_232[send_232_read];
  send_232_read++;
  send_232_free++;
  if (send_232_read == send_232_size) {
    send_232_read = 0;
  }
} else
  fifo_error(9);
return value;
}

u08 rec_232_status(void) {
u08 status;
status = 1;
UCSRB &= ~(1<<RXCIE); //UART Recive Int deakivieren
if (rec_232_free == 0) status = 2; //voll
if (rec_232_free == rec_232_size) status = 0; //leer
UCSRB |= (1<<RXCIE); //UART Recive Int wieder aktivieren
return status;
}

/*Die Routine send_232_get() steht nicht hier, sondern  in rs232_io.c
  um untiges push und pop der regiser zu verhindern, und somit einen
  schnelleren/kleineren Code zu erhalten */

u08 rec_232_get(void) {
u08 value = 0;
/*rec_232_free ist ein 16 bit wert, der whrend des lesens nich im
uart interrupt verndert werden darf. daher wird der interrupt kurzzeitig deaktiviert
*/
UCSRB &= ~(1<<RXCIE); //UART Recive Int deakivieren
if (rec_232_free != rec_232_size) {
  value = rec_232[rec_232_read];
  rec_232_read++;
  rec_232_free++;
  if (rec_232_read == rec_232_size) {
    rec_232_read = 0;
  }
} else
  fifo_error(10);
UCSRB |= (1<<RXCIE); //UART Recive Int wieder aktivieren
return value;
}
