//Interface mit der RS232 Schnittstelle

#include "main.h"


void rs232int_init(void) {
UBRRL = rs232ubrr; //Geschwindigkeit einstellen
//RX Int, TX Enabled, RX Enabled
UCSRB = 1<<RXCIE | 1<<RXEN | 1<<TXEN;
}

SIGNAL(SIG_UART_RECV) {
u08 rvalue;
//Im USART0_RECV darf sich der Interupt nicht selbst aufrufen
UCSRB &= ~(1<<RXCIE);
sei(); //Damit Timer2 zwischenzeitlich auslsen darf
/*Die Routine steht nicht als send_232_get() in ringbuffer.c sondern hier,
  um untiges push und pop der regiser zu verhindern, und somit einen
  schnelleren/kleineren Code zu erhalten */
/* UDR muss ausgelesen werden, unabhngig ob Platz im Ringbuffer vorhanden
   ist, da sonst die Daten in UDR sofort einen neuen Interrup auslsen
   wrden, was zu einer Endlosschleife fhren wrde, sollte rec_232 erst
   einmal voll sein.
*/
rvalue = UDR; //UDR muss ausgelesen werden
if (rec_232_free != 0) {
  rec_232_free--;
  rec_232[rec_232_write] = rvalue;
  rec_232_write++;
  if (rec_232_write == rec_232_size) {
    rec_232_write = 0;
  }
}
UCSRB |= (1<<RXCIE);//Interrupt wieder aktiv
}

void io_232_send(void) {
  if (send_232_status() != 0) {
    if ((UCSRA & (1<<UDRE)) != 0) { //Wenn UDR Daten aufnehmen kann
      UDR = send_232_get();
    }
  }
}

